FUNCTION_BLOCK Lcd_ClearScreen
VAR_INPUT

    I2cHandle_i                 : HI2C;
    xEnable_i                   : BOOL;

END_VAR

VAR_OUTPUT

    usiError_o                  : USINT             := 0;
    xConfirm_o                  : BOOL              := FALSE;

END_VAR

VAR

    FB_Lcd_Write_Cmd            : Lcd_Write_Cmd;

    bCommand                    : BYTE;
    bMode                       : BYTE;

    xConfirm                    : BOOL;
    usiError                    : USINT;

    FB_RTrig                    : R_TRIG;
    iProcState                  : INT               := 0;

END_VAR


    FB_RTrig (CLK := xEnable_i);
    IF (FB_RTrig.Q = TRUE) THEN
        iProcState := 0;
        usiError_o := 0;
        xConfirm_o := FALSE;
    END_IF;

    IF (xEnable_i = FALSE) THEN
        RETURN;
    END_IF;


    CASE iProcState OF

    (* ------------------------------------------------------------------------------------ *)
    (*  lcddriver.lcd_clear.lcd_write(LCD_CLEARDISPLAY)                                     *)
    (* ------------------------------------------------------------------------------------ *)

    0:  FB_Lcd_Write_Cmd (xEnable_i := FALSE);
        iProcState := iProcState + 1;

    1:
        bCommand := LCD_CLEARDISPLAY;
        bMode    := 16#00;
        FB_Lcd_Write_Cmd (
            xEnable_i   := TRUE,
            I2cHandle_i := I2cHandle_i,
            bCommand_i  := bCommand,
            bMode_i     := bMode
            |
            xConfirm    := xConfirm_o,
            usiError    := usiError_o);

        IF (xConfirm = TRUE) THEN
            iProcState := iProcState + 1;
            RETURN;
        END_IF;

        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;


    (* ------------------------------------------------------------------------------------ *)
    (*  lcddriver.lcd_clear.lcd_write(LCD_RETURNHOME)                                       *)
    (* ------------------------------------------------------------------------------------ *)

    2:  FB_Lcd_Write_Cmd (xEnable_i := FALSE);
        iProcState := iProcState + 1;

    3:
        bCommand := LCD_RETURNHOME;
        bMode    := 16#00;
        FB_Lcd_Write_Cmd (
            xEnable_i   := TRUE,
            I2cHandle_i := I2cHandle_i,
            bCommand_i  := bCommand,
            bMode_i     := bMode
            |
            xConfirm    := xConfirm_o,
            usiError    := usiError_o);

        IF (xConfirm = TRUE) THEN
            iProcState := iProcState + 1;
            RETURN;
        END_IF;

        IF (usiError <> 0) THEN
            iProcState := -1;
        END_IF;


    (* ------------------------------------------------------------------------------------ *)
    (*  Finish                                                                              *)
    (* ------------------------------------------------------------------------------------ *)

    4:  (* ---- Finish ---- *)

        usiError_o := 0;
        xConfirm_o := TRUE;
        RETURN;


    (* ------------------------------------------------------------------------------------ *)
    (*  Error                                                                               *)
    (* ------------------------------------------------------------------------------------ *)

    -1:  (* ---- Error ---- *)
        usiError_o := usiError;
        xConfirm_o := FALSE;
        RETURN;

    ELSE
        RETURN;

    END_CASE;



    RETURN;



END_FUNCTION_BLOCK